<?php
/*********************************************************************
    class.nav.php

    Navigation helper classes. Pointless BUT helps keep navigation clean and free from errors.

    Peter Rotich <peter@osticket.com>
    Copyright (c)  2006-2010 osTicket
    http://www.osticket.com

    Released under the GNU General Public License WITHOUT ANY WARRANTY.
    See LICENSE.TXT for details.

    vim: expandtab sw=4 ts=4 sts=4:
    $Id: $
**********************************************************************/
class StaffNav {
    var $tabs=array();
    var $submenu=array();

    var $activetab;
    var $ptype;

    function StaffNav($pagetype='staff'){
        global $thisuser;

        $this->ptype=$pagetype;
        $tabs=array();
        if($thisuser->isAdmin() && strcasecmp($pagetype,'admin')==0) {
            $tabs['dashboard']=array('desc'=>'Главная','href'=>'admin.php?t=dashboard','title'=>'Главная');
            $tabs['settings']=array('desc'=>'Настройки','href'=>'admin.php?t=settings','title'=>'Системные настройки');
            $tabs['emails']=array('desc'=>'Emails','href'=>'admin.php?t=email','title'=>'Настройки Email');
            $tabs['topics']=array('desc'=>'Тема обращения','href'=>'admin.php?t=topics','title'=>'Тема обращения');
            $tabs['staff']=array('desc'=>'Пользователи','href'=>'admin.php?t=staff','title'=>'Пользователи');
            $tabs['depts']=array('desc'=>'Отделы','href'=>'admin.php?t=depts','title'=>'Отделы');
        }else {
            $tabs['tickets']=array('desc'=>'Заявки','href'=>'tickets.php','title'=>'Заявки');
            if($thisuser && $thisuser->canManageKb()){
             $tabs['kbase']=array('desc'=>'База Знаний','href'=>'kb.php','title'=>'База Знаний');
            }
            $tabs['directory']=array('desc'=>'Менеджеры','href'=>'directory.php','title'=>'Менеджеры');
            $tabs['profile']=array('desc'=>'Мой аккаунт','href'=>'profile.php','title'=>'Мой профиль');
        }
        $this->tabs=$tabs;    
    }
    
    
    function setTabActive($tab){
            
        if($this->tabs[$tab]){
            $this->tabs[$tab]['active']=true;
            if($this->activetab && $this->activetab!=$tab && $this->tabs[$this->activetab])
                 $this->tabs[$this->activetab]['active']=false;
            $this->activetab=$tab;
            return true;
        }
        return false;
    }
    
    function addSubMenu($item,$tab=null) {
        
        $tab=$tab?$tab:$this->activetab;
        $this->submenu[$tab][]=$item;
    }

    
    
    function getActiveTab(){
        return $this->activetab;
    }        

    function getTabs(){
        return $this->tabs;
    }

    function getSubMenu($tab=null){
      
        $tab=$tab?$tab:$this->activetab;  
        return $this->submenu[$tab];
    }
    
}
?>
